import { Box, Tab } from "@mui/material";
import {TabContext, TabList, TabPanel} from '@mui/lab';
import React from "react";
import Collapsible from "../components/Collapsible"; 

export function Wiki  () {

  return (
       <>
      <div className="row">
        <div className="col">
           <WikiTabs></WikiTabs> 
        </div>
      </div>
      <div className="row">
        <div className="d-flex flex-column justify-content-center align-items-center">
        </div>
      </div>
    </>
  );
}


 export function WikiTabs() {
  const [value, setValue] = React.useState('1');

  const handleChange = (_event: React.SyntheticEvent, newValue: string) => {
    setValue(newValue);
  };

  return (
    <Box sx={{ width: '100%', typography: 'body1' }}>
      <TabContext value={value}>
        <Box sx={{ borderBottom: 1, borderColor: 'divider' }}>
          <TabList onChange={handleChange} aria-label="lab API tabs example">
            <Tab label="About" value="1" />
            <Tab label="Getting started" value="6" />
            <Tab label="Troubleshooting" value="2" />
            <Tab label="Components" value="3" />
            <Tab label="Downloads" value="4" />
            <Tab label="Resources" value="5" />
            
          </TabList>
        </Box>
        <TabPanel value="1">   </TabPanel>
        <TabPanel value="6"> <Started/>  </TabPanel>
        <TabPanel value="2"> <Troubleshooting/> </TabPanel>
        <TabPanel value="3">  </TabPanel>
        <TabPanel value="4">   </TabPanel>
        <TabPanel value="5">  <Sources/> </TabPanel>
      </TabContext>
    </Box>
  );
}

function Started(){

  return(
    <>
    <h3>Differences between React and plain HTML</h3>
    <p>There are some differences in the syntax that can lead to errors.</p>
    <table>
      <tr>
        <th></th>
        <th>Plain HTML</th>
        <th>Using React</th>
      </tr>
      <tr>
        <th> <code>&lt;tags&gt; </code> </th>
        <th> 
          <p> Most tags have to be opened and closed, but some can be only opened. </p> 
          <p> e.g. img, br, ... <code> &lt;img src:"somesource" alt="alt"&gt;  </code> </p>
        </th>
        <th>
          <p> Every tag has to be closed.  </p>
          <p> e.g. img, br, ... 
            <code> &lt;img src:"somesource" alt="alt"/&gt;</code> or 
            <code> &lt;img src:"somesource" alt="alt"&gt; &lt;/img&gt; </code>  </p>
        </th>
      </tr>
      <tr>
        <th>Attribute Names</th>
        <th>
          <p> Global attribute names are always written in lowercase and two words are fused into one by "-". </p>
          <p> E.g. "class", "charset", ...</p>
          <p> This is also the case when using the syle-attribute. </p>
          <p> E.g. <code>style="color:blue; text-align:center"</code></p>
        </th>
        <th> 
          <p>Global attribute names are generally written in lowercase but use the camel case if two words have to be fused. Some attrubutes have slightly different names.</p>
          <p>E.g. "className", "charSet", ...</p>
          <p> This is also the case when using the style-attribute.</p>
          <p> E.g. <code>style=&#123;&#123;vectorEffect: &quot;non-scaling-stroke&quot;&#125;&#125;</code></p>
          <p>This does not apply to the css file!</p>
        </th>
      </tr>
      <tr>
        <th>Style attribute</th>
        <th>
          <p> style="<var>attribute</var>: <var>value</var>; <var>attribute</var>: <var>value</var>" </p>
        </th>
        <th>
          <p> style=&#123;&#123;<var>attribute</var>: "<var>value</var>", <var>attribute</var>: "<var>value</var>" &#125;&#125;</p>
        </th>
      </tr>
    </table>
    </>
  )
}


 function Sources(){
  return(
    <div>
      <Collapsible title="Images and Icons" >
      Most teams need a lot of pictures, components, icons and alike. They can be difficult to find, especially free and open source ones.
      
        <ul>
          <li> <a href="https://bioicons.com/"> https://bioicons.com/</a> </li>
          <li> <a href="https://togotv.dbcls.jp/en/pics.html" > https://togotv.dbcls.jp/en/pics.html </a> </li>
          <li> <a href="https://smart.servier.com/" >https://smart.servier.com/</a> </li>
          <li> <a href="https://openclipart.org/" > https://openclipart.org/</a> </li>
          <li> <a href="https://commons.wikimedia.org/wiki/Category:SVG_files" >https://commons.wikimedia.org/wiki/Category:SVG_files</a> </li>
          <li> <a href="https://www.flaticon.com/">https://www.flaticon.com/</a> </li>
          <li> <a href="https://biologicalicons.com/en">https://biologicalicons.com/en</a> </li>
          <li> <a href="https://www.svgrepo.com/">https://www.svgrepo.com/</a> </li>
          <li> <a href="https://www.humanbiomedia.org/">https://www.humanbiomedia.org/</a> </li>
        </ul>

      </Collapsible>
      <Collapsible title="Colours" >
        Need a slightly lighter version of one of your colours or a mix of two colours? 
        <ul>
          <li><a href="https://www.w3schools.com/colors/colors_mixer.asp"> https://www.w3schools.com/colors/colors_mixer.asp</a></li>
        </ul>
      </Collapsible>
      <Collapsible title="Coding Tools">
        Generators
        <ul>
          <li><a href="https://www.cssportal.com/">https://www.cssportal.com/</a></li>
          <li><a href="https://htmlcss.tools/">https://htmlcss.tools/</a></li>
        </ul>
      </Collapsible>

      <Collapsible title="Placeholders">
        <ul>
          <li><a href="https://www.loremipsum.de/">https://www.loremipsum.de/</a></li>
        </ul>
      </Collapsible>

      <Collapsible title="SVGs">
        <ul>
          <li><a href="https://superdesigner.co/tools/svg-backgrounds">https://superdesigner.co/tools/svg-backgrounds</a></li>
        </ul>
      </Collapsible>

      <Collapsible title="Accessibility">
      <ul>
        <li><a href="https://schema.org">https://schema.org</a></li>
      </ul>
      </Collapsible>
    </div>

  )
} 



import { Selector } from "../components/Filter";
function Troubleshooting(){
  
  return(
    <div>
      Please select what you want to troubleshoot for. 
      <Selector></Selector>
      <div id="nono" className="noshow">
        This combination returns no instances. 
      </div>
      <div className="filterable all react type property">
        <Collapsible title="Argument of type X is not assignable to parameter of type Y.">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react type"> 
        <Collapsible title="Type X is not assignable to type Y.">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all  react type property">
        <Collapsible title="Property x is missing in type y but required in type z.">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react type property">
        <Collapsible title="Property x does not exist on type Y.">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react type property">
        <Collapsible title="Type X is missing the following properties from type Y: a, b, c">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react type">
        <Collapsible title="Type 'x | undefined' is not assignable to type 'x'.">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react type">
        <Collapsible title="Type 'undefined' cannot be used as an index type">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react overload">
        <Collapsible title="No overload matches this call.">
        <h6>Example</h6>
        <h6>Solutions</h6>
        </Collapsible>
      </div>
      <div className="filterable all react module">
        <Collapsible title="Module Z has already exported a member named A. Consider explicitly re-exporting to resolve the ambiguity.">
        <h6>Example</h6>
        index.tsx: 
        <p className="error"> Module "./Bfh.tsx" has already exported a member named 'LabTabs'. Consider explicitly re-exporting to resolve the ambiguity.</p>
        <h6>Solutions</h6>
        Simply rename the function in one of the modules or consider making it a component if you plan on using it frequently.  
        </Collapsible>
      </div>
      <div className="filterable all pipeline">
        <Collapsible title="error TS6133: 'event' is declared but its value is never read.">
          <h6>Example</h6>
          HorizontalTimeline.tsx: 
          <div className="error">
            $ yarn build
            <p>yarn run v1.22.19</p>
            <p>$ tsc && vite build</p>
            <p>src/components/HorizontalTimeline.tsx(67,23): error TS6133: 'event' is declared but its value is never read.
            error Command failed with exit code 2.</p>
            <p>info Visit https://yarnpkg.com/en/docs/cli/run for documentation about this command.</p>
            </div>
          <p>in</p>
          <code>
          const openPop =  (event : React.MouseEvent&lt;HTMLButtonElement, MouseEvent&gt;) =&gt; {}
          </code>
          <h6>Solutions</h6>
          <p>Change to: </p>
          <code>
          const openPop =  (_event : React.MouseEvent&lt;HTMLButtonElement, MouseEvent&gt;) =&gt; {}
          </code>
        </Collapsible>
      </div>
    </div>
  )
} 


